/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _dtos18.c,v 1.2 1994/11/27 13:05:20 mura Exp $
 */

/* System headers */
#include <stdlib.h>
#include <sys/xstdlib.h>

/*
** {֐͕_{xɕϊĂ當ɂ邽߁AxIɂ
** {xɊi[ł錅܂łƂłȂBčōx
** 18łB
*/

/* File scope variables */
static const double _pos1[16] = {
    1.0e+17,					/* + 0 */
    1.0e+18,					/* + 1 */
    1.0e+19,					/* + 2 */
    1.0e+20,					/* + 3 */
    1.0e+21,					/* + 4 */
    1.0e+22,					/* + 5 */
    1.0e+23,					/* + 6 */
    1.0e+24,					/* + 7 */
    1.0e+25,					/* + 8 */
    1.0e+26,					/* + 9 */
    1.0e+27,					/* +10 */
    1.0e+28,					/* +11 */
    1.0e+29,					/* +12 */
    1.0e+30,					/* +13 */
    1.0e+31,					/* +14 */
    1.0e+32,					/* +15 */
};

/* File scope variables */
static const double _neg1[16] = {
    1.0e+17,					/* - 0 */
    1.0e+16,					/* - 1 */
    1.0e+15,					/* - 2 */
    1.0e+14,					/* - 3 */
    1.0e+13,					/* - 4 */
    1.0e+12,					/* - 5 */
    1.0e+11,					/* - 6 */
    1.0e+10,					/* - 7 */
    1.0e+9,					/* - 8 */
    1.0e+8,					/* - 9 */
    1.0e+7,					/* -10 */
    1.0e+6,					/* -11 */
    1.0e+5,					/* -12 */
    1.0e+4,					/* -13 */
    1.0e+3,					/* -14 */
    1.0e+2,					/* -15 */
};

/* File scope variables */
static const double _pos2[19] = {
    1.0e+16,					/*  1 */
    1.0e+32,					/*  2 */
    1.0e+48,					/*  3 */
    1.0e+64,					/*  4 */
    1.0e+80,					/*  5 */
    1.0e+96,					/*  6 */
    1.0e+112,					/*  7 */
    1.0e+128,					/*  8 */
    1.0e+144,					/*  9 */
    1.0e+160,					/* 10 */
    1.0e+176,					/* 11 */
    1.0e+192,					/* 12 */
    1.0e+208,					/* 13 */
    1.0e+224,					/* 14 */
    1.0e+240,					/* 15 */
    1.0e+256,					/* 16 */
    1.0e+272,					/* 17 */
    1.0e+288,					/* 18 */
    1.0e+304,					/* 19 */
};

/* File scope variables */
static const double _neg2[19] = {
    1.0e-16,					/*  1 */
    1.0e-32,					/*  2 */
    1.0e-48,					/*  3 */
    1.0e-64,					/*  4 */
    1.0e-80,					/*  5 */
    1.0e-96,					/*  6 */
    1.0e-112,					/*  7 */
    1.0e-128,					/*  8 */
    1.0e-144,					/*  9 */
    1.0e-160,					/* 10 */
    1.0e-176,					/* 11 */
    1.0e-192,					/* 12 */
    1.0e-208,					/* 13 */
    1.0e-224,					/* 14 */
    1.0e-240,					/* 15 */
    1.0e-256,					/* 16 */
    1.0e-272,					/* 17 */
    1.0e-288,					/* 18 */
    1.0e-304,					/* 19 */
};

/* File scope functions */
static int _cmpd (double x, double y)
{
    unsigned long vx, vy, rc;
    unsigned long *x_ptr = (unsigned long *) &x;
    unsigned long *y_ptr = (unsigned long *) &y;

    /* x̎wrbgo */
    vx = x_ptr[0] & 0x7FF00000;

    /* y̎wrbgo */
    vy = y_ptr[0] & 0x7FF00000;

    /* wrbgŔf */
    if ((rc = vy - vx) != 0)
	return rc;

    /* x̗L̏ʃrbgo */
    vx = x_ptr[0] & 0x000FFFFF;

    /* y̗L̏ʃrbgo */
    vy = y_ptr[0] & 0x000FFFFF;

    /* ʃrbgŔf */
    if ((rc = vy - vx) != 0)
	return rc;

    /* x̗L̉ʃrbgo */
    vx = x_ptr[1];

    /* y̗L̉ʃrbgo */
    vy = y_ptr[1];

    /* ŏIf */
    return vy - vx;
}

/* Functions */
void _dtos18 (double x, int *decpt, int *sign, char *buffer)
{
    short e2;
    int e;

    /* vZ */
    *sign = ((unsigned char *) &x)[0] & 0x80U;

    /* 2̎w߂(oCAXȂ̏) */
    e2 = (((unsigned short *) &x)[0] & 0x7FF0U) >> 4;

    /* w0̏ꍇ́}0.0`FbN */
    if (e2 == 0) {

	unsigned long hi = ((unsigned long *) &x)[0] & 0xFFFFF;
	unsigned long lo = ((unsigned long *) &x)[1];

	/* LS0ǂ */
	if (hi == 0 && lo == 0) {

	    /* ݒ */
	    buffer[0] = '0';

	    /* NULݒ */
	    buffer[1] = '\0';

	    /* _ʒuvZ */
	    *decpt = 1;

	    /* m */
	    return;

	}

    }

    /* 2̎wɃoCAXĂ10̎wTZ (approx. log10(2)) */
    e = ((int) ((e2 - 1023) * 77)) >> 8;

    {
	const double *tbl1, *tbl2;
	int n;

	/* w̏ꍇ */
	tbl1 = _neg1;
	tbl2 = _neg2;
	n = e;

	/* w̏ꍇ */
	if (n < 0) {

	    tbl1 = _pos1;
	    tbl2 = _pos2;

	    /* ΒlvZ */
	    n = -n;

	}

	/* w16ȏ̏ꍇ̓e[u1,2 */
	if (n >> 4)
	    x *= tbl2[(n >> 4) - 1];

	/* w16菬ꍇ̓e[u1 */
	x *= tbl1[n & 15];

    }

    /* XP[Oꍇ͖߂ */
    if (_cmpd (1.0e+18, x) >= 0) {
	e++;
	x *= 1.0e-1;
    }

    /* XP[OȂꍇ͒ǉ */
    else if (_cmpd (1.0e+17, x) < 0) {
	e--;
	x *= 1.0e+1;
    }

    /* _ʒuvZ */
    *decpt = e + 1;

    /* ɕϊ */
    _ulltoa ((unsigned long long) x, buffer);
}
